#define Uses_TApp
#define Uses_TResourceFile
#define Uses_RefStrCollection
#define Uses_fpstream
#define Uses_MsgBox
#define Uses_TMenuBar
#define Uses_TStatusLine
#define Uses_TDeskTop
#define Uses_StringIds
#include "Prog.h"

TResourceFile* TApp::rez = 0;
RefStrCollection& TApp::strings = *new RefStrCollection(0);

TApp::TApp() :
	TProgInit(0, 0, initDeskTop),
	isValid(True)
{
	fpstream* fs = new fpstream(rezName, ios::in|ios::binary|ios::nocreate);
	if(!fs->good())
		{
		messageBox(badRezFile, mfError|mfOKButton);
		isValid = False;
		delete fs;
		}
	else
		{
		rez = new TResourceFile(fs);
		initialize();
		}
}

Boolean TApp::valid(ushort command)
{
	if(command == cmValid && !isValid)
		return False;
	else
		return TApplication::valid(command);
}

TDeskTop* TApp::initDeskTop(TRect r)
{
	// At startup, we want a full-screen desktop.
	return new TDeskTop(r);
}

static void* readResource(const char* name)
{
	void* ptr = TApp::rez->get(name);
	if(ptr == 0)
		messageBox(TApp::strings[sMissingResource], mfError|mfOKButton);
	return ptr;
}

void TApp::initialize()
{
	TRect r;

	// Read in the strings collection; fail if necessary.
	RefStrCollection* rs = (RefStrCollection*) rez->get(stringsName);
	if(rs == 0 || rs->getCount() == 0)
		{
		delete rs;
		isValid = False;
		messageBox(badRezFile, mfError|mfOKButton);
		}
	else
		{
		delete &strings;
		strings = *rs;
		}

	if(isValid)
		{
		menuBar = (TMenuBar*) readResource(rezMenuBar);
		if(menuBar == 0)
			isValid = False;
		else
			{
			r = getExtent();
			r.b.y = r.a.y+1;
			menuBar->locate(r);
			insert(menuBar);
			}
		}

	if(isValid)
		{
		statusLine = (TStatusLine*) readResource(rezStatusLine);
		if(statusLine == 0)
			isValid = False;
		else
			{
			r = getExtent();
			r.a.y = r.b.y-1;
			statusLine->locate(r);
			insert(statusLine);
			}
		}

	if(isValid)
		{
		TDeskTop* dt = (TDeskTop*) readResource(rezDeskTop);
		if(dt == 0)
			isValid = False;
		else
			{
			r = getExtent();
			r.a.y++;	r.b.y--;
			dt->locate(r);
			destroy(deskTop);
			deskTop = dt;
			insert(deskTop);
			}
		}
}
